# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.237
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class AmortisationRule(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'name': 'str',
        'description': 'str',
        'filter': 'str',
        'amortisation_method': 'str'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'filter': 'filter',
        'amortisation_method': 'amortisationMethod'
    }

    required_map = {
        'name': 'required',
        'description': 'optional',
        'filter': 'required',
        'amortisation_method': 'required'
    }

    def __init__(self, name=None, description=None, filter=None, amortisation_method=None, local_vars_configuration=None):  # noqa: E501
        """AmortisationRule - a model defined in OpenAPI"
        
        :param name:  The name of the rule. (required)
        :type name: str
        :param description:  A description of the rule.
        :type description: str
        :param filter:  The filter for this rule. (required)
        :type filter: str
        :param amortisation_method:  The filter for this rule. (required)
        :type amortisation_method: str

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._description = None
        self._filter = None
        self._amortisation_method = None
        self.discriminator = None

        self.name = name
        self.description = description
        self.filter = filter
        self.amortisation_method = amortisation_method

    @property
    def name(self):
        """Gets the name of this AmortisationRule.  # noqa: E501

        The name of the rule.  # noqa: E501

        :return: The name of this AmortisationRule.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AmortisationRule.

        The name of the rule.  # noqa: E501

        :param name: The name of this AmortisationRule.  # noqa: E501
        :type name: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) > 256):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `256`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and not re.search(r'^[^\\<>&\"]+$', name)):  # noqa: E501
            raise ValueError(r"Invalid value for `name`, must be a follow pattern or equal to `/^[^\\<>&\"]+$/`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this AmortisationRule.  # noqa: E501

        A description of the rule.  # noqa: E501

        :return: The description of this AmortisationRule.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this AmortisationRule.

        A description of the rule.  # noqa: E501

        :param description: The description of this AmortisationRule.  # noqa: E501
        :type description: str
        """
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) > 1024):
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1024`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) < 0):
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `0`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and not re.search(r'^[\s\S]*$', description)):  # noqa: E501
            raise ValueError(r"Invalid value for `description`, must be a follow pattern or equal to `/^[\s\S]*$/`")  # noqa: E501

        self._description = description

    @property
    def filter(self):
        """Gets the filter of this AmortisationRule.  # noqa: E501

        The filter for this rule.  # noqa: E501

        :return: The filter of this AmortisationRule.  # noqa: E501
        :rtype: str
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """Sets the filter of this AmortisationRule.

        The filter for this rule.  # noqa: E501

        :param filter: The filter of this AmortisationRule.  # noqa: E501
        :type filter: str
        """
        if self.local_vars_configuration.client_side_validation and filter is None:  # noqa: E501
            raise ValueError("Invalid value for `filter`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                filter is not None and len(filter) > 16384):
            raise ValueError("Invalid value for `filter`, length must be less than or equal to `16384`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                filter is not None and len(filter) < 0):
            raise ValueError("Invalid value for `filter`, length must be greater than or equal to `0`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                filter is not None and not re.search(r'^[\s\S]*$', filter)):  # noqa: E501
            raise ValueError(r"Invalid value for `filter`, must be a follow pattern or equal to `/^[\s\S]*$/`")  # noqa: E501

        self._filter = filter

    @property
    def amortisation_method(self):
        """Gets the amortisation_method of this AmortisationRule.  # noqa: E501

        The filter for this rule.  # noqa: E501

        :return: The amortisation_method of this AmortisationRule.  # noqa: E501
        :rtype: str
        """
        return self._amortisation_method

    @amortisation_method.setter
    def amortisation_method(self, amortisation_method):
        """Sets the amortisation_method of this AmortisationRule.

        The filter for this rule.  # noqa: E501

        :param amortisation_method: The amortisation_method of this AmortisationRule.  # noqa: E501
        :type amortisation_method: str
        """
        if self.local_vars_configuration.client_side_validation and amortisation_method is None:  # noqa: E501
            raise ValueError("Invalid value for `amortisation_method`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                amortisation_method is not None and len(amortisation_method) < 1):
            raise ValueError("Invalid value for `amortisation_method`, length must be greater than or equal to `1`")  # noqa: E501

        self._amortisation_method = amortisation_method

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AmortisationRule):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AmortisationRule):
            return True

        return self.to_dict() != other.to_dict()
