# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.237
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class FundConfiguration(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'href': 'str',
        'id': 'ResourceId',
        'display_name': 'str',
        'description': 'str',
        'dealing_filters': 'list[ComponentFilter]',
        'pnl_filters': 'list[ComponentFilter]',
        'back_out_filters': 'list[ComponentFilter]',
        'properties': 'dict(str, ModelProperty)',
        'version': 'Version',
        'links': 'list[Link]'
    }

    attribute_map = {
        'href': 'href',
        'id': 'id',
        'display_name': 'displayName',
        'description': 'description',
        'dealing_filters': 'dealingFilters',
        'pnl_filters': 'pnlFilters',
        'back_out_filters': 'backOutFilters',
        'properties': 'properties',
        'version': 'version',
        'links': 'links'
    }

    required_map = {
        'href': 'optional',
        'id': 'required',
        'display_name': 'optional',
        'description': 'optional',
        'dealing_filters': 'optional',
        'pnl_filters': 'optional',
        'back_out_filters': 'optional',
        'properties': 'optional',
        'version': 'optional',
        'links': 'optional'
    }

    def __init__(self, href=None, id=None, display_name=None, description=None, dealing_filters=None, pnl_filters=None, back_out_filters=None, properties=None, version=None, links=None, local_vars_configuration=None):  # noqa: E501
        """FundConfiguration - a model defined in OpenAPI"
        
        :param href:  The specific Uniform Resource Identifier (URI) for this resource at the requested effective and asAt datetime.
        :type href: str
        :param id:  (required)
        :type id: lusid.ResourceId
        :param display_name:  The name of the FundConfiguration.
        :type display_name: str
        :param description:  A description for the FundConfiguration.
        :type description: str
        :param dealing_filters:  The set of filters used to decide which JE lines are included in the dealing.
        :type dealing_filters: list[lusid.ComponentFilter]
        :param pnl_filters:  The set of filters used to decide which JE lines are included in the PnL.
        :type pnl_filters: list[lusid.ComponentFilter]
        :param back_out_filters:  The set of filters used to decide which JE lines are included in the back outs.
        :type back_out_filters: list[lusid.ComponentFilter]
        :param properties:  A set of properties for the Fund Configuration.
        :type properties: dict[str, lusid.ModelProperty]
        :param version: 
        :type version: lusid.Version
        :param links: 
        :type links: list[lusid.Link]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._href = None
        self._id = None
        self._display_name = None
        self._description = None
        self._dealing_filters = None
        self._pnl_filters = None
        self._back_out_filters = None
        self._properties = None
        self._version = None
        self._links = None
        self.discriminator = None

        self.href = href
        self.id = id
        self.display_name = display_name
        self.description = description
        self.dealing_filters = dealing_filters
        self.pnl_filters = pnl_filters
        self.back_out_filters = back_out_filters
        self.properties = properties
        if version is not None:
            self.version = version
        self.links = links

    @property
    def href(self):
        """Gets the href of this FundConfiguration.  # noqa: E501

        The specific Uniform Resource Identifier (URI) for this resource at the requested effective and asAt datetime.  # noqa: E501

        :return: The href of this FundConfiguration.  # noqa: E501
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """Sets the href of this FundConfiguration.

        The specific Uniform Resource Identifier (URI) for this resource at the requested effective and asAt datetime.  # noqa: E501

        :param href: The href of this FundConfiguration.  # noqa: E501
        :type href: str
        """

        self._href = href

    @property
    def id(self):
        """Gets the id of this FundConfiguration.  # noqa: E501


        :return: The id of this FundConfiguration.  # noqa: E501
        :rtype: lusid.ResourceId
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this FundConfiguration.


        :param id: The id of this FundConfiguration.  # noqa: E501
        :type id: lusid.ResourceId
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def display_name(self):
        """Gets the display_name of this FundConfiguration.  # noqa: E501

        The name of the FundConfiguration.  # noqa: E501

        :return: The display_name of this FundConfiguration.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this FundConfiguration.

        The name of the FundConfiguration.  # noqa: E501

        :param display_name: The display_name of this FundConfiguration.  # noqa: E501
        :type display_name: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this FundConfiguration.  # noqa: E501

        A description for the FundConfiguration.  # noqa: E501

        :return: The description of this FundConfiguration.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this FundConfiguration.

        A description for the FundConfiguration.  # noqa: E501

        :param description: The description of this FundConfiguration.  # noqa: E501
        :type description: str
        """

        self._description = description

    @property
    def dealing_filters(self):
        """Gets the dealing_filters of this FundConfiguration.  # noqa: E501

        The set of filters used to decide which JE lines are included in the dealing.  # noqa: E501

        :return: The dealing_filters of this FundConfiguration.  # noqa: E501
        :rtype: list[lusid.ComponentFilter]
        """
        return self._dealing_filters

    @dealing_filters.setter
    def dealing_filters(self, dealing_filters):
        """Sets the dealing_filters of this FundConfiguration.

        The set of filters used to decide which JE lines are included in the dealing.  # noqa: E501

        :param dealing_filters: The dealing_filters of this FundConfiguration.  # noqa: E501
        :type dealing_filters: list[lusid.ComponentFilter]
        """

        self._dealing_filters = dealing_filters

    @property
    def pnl_filters(self):
        """Gets the pnl_filters of this FundConfiguration.  # noqa: E501

        The set of filters used to decide which JE lines are included in the PnL.  # noqa: E501

        :return: The pnl_filters of this FundConfiguration.  # noqa: E501
        :rtype: list[lusid.ComponentFilter]
        """
        return self._pnl_filters

    @pnl_filters.setter
    def pnl_filters(self, pnl_filters):
        """Sets the pnl_filters of this FundConfiguration.

        The set of filters used to decide which JE lines are included in the PnL.  # noqa: E501

        :param pnl_filters: The pnl_filters of this FundConfiguration.  # noqa: E501
        :type pnl_filters: list[lusid.ComponentFilter]
        """

        self._pnl_filters = pnl_filters

    @property
    def back_out_filters(self):
        """Gets the back_out_filters of this FundConfiguration.  # noqa: E501

        The set of filters used to decide which JE lines are included in the back outs.  # noqa: E501

        :return: The back_out_filters of this FundConfiguration.  # noqa: E501
        :rtype: list[lusid.ComponentFilter]
        """
        return self._back_out_filters

    @back_out_filters.setter
    def back_out_filters(self, back_out_filters):
        """Sets the back_out_filters of this FundConfiguration.

        The set of filters used to decide which JE lines are included in the back outs.  # noqa: E501

        :param back_out_filters: The back_out_filters of this FundConfiguration.  # noqa: E501
        :type back_out_filters: list[lusid.ComponentFilter]
        """

        self._back_out_filters = back_out_filters

    @property
    def properties(self):
        """Gets the properties of this FundConfiguration.  # noqa: E501

        A set of properties for the Fund Configuration.  # noqa: E501

        :return: The properties of this FundConfiguration.  # noqa: E501
        :rtype: dict[str, lusid.ModelProperty]
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this FundConfiguration.

        A set of properties for the Fund Configuration.  # noqa: E501

        :param properties: The properties of this FundConfiguration.  # noqa: E501
        :type properties: dict[str, lusid.ModelProperty]
        """

        self._properties = properties

    @property
    def version(self):
        """Gets the version of this FundConfiguration.  # noqa: E501


        :return: The version of this FundConfiguration.  # noqa: E501
        :rtype: lusid.Version
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this FundConfiguration.


        :param version: The version of this FundConfiguration.  # noqa: E501
        :type version: lusid.Version
        """

        self._version = version

    @property
    def links(self):
        """Gets the links of this FundConfiguration.  # noqa: E501


        :return: The links of this FundConfiguration.  # noqa: E501
        :rtype: list[lusid.Link]
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this FundConfiguration.


        :param links: The links of this FundConfiguration.  # noqa: E501
        :type links: list[lusid.Link]
        """

        self._links = links

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FundConfiguration):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FundConfiguration):
            return True

        return self.to_dict() != other.to_dict()
