# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.237
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class FundConfigurationRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'code': 'str',
        'display_name': 'str',
        'description': 'str',
        'dealing_filters': 'list[ComponentFilter]',
        'pnl_filters': 'list[ComponentFilter]',
        'back_out_filters': 'list[ComponentFilter]',
        'properties': 'dict(str, ModelProperty)'
    }

    attribute_map = {
        'code': 'code',
        'display_name': 'displayName',
        'description': 'description',
        'dealing_filters': 'dealingFilters',
        'pnl_filters': 'pnlFilters',
        'back_out_filters': 'backOutFilters',
        'properties': 'properties'
    }

    required_map = {
        'code': 'required',
        'display_name': 'optional',
        'description': 'optional',
        'dealing_filters': 'required',
        'pnl_filters': 'required',
        'back_out_filters': 'required',
        'properties': 'optional'
    }

    def __init__(self, code=None, display_name=None, description=None, dealing_filters=None, pnl_filters=None, back_out_filters=None, properties=None, local_vars_configuration=None):  # noqa: E501
        """FundConfigurationRequest - a model defined in OpenAPI"
        
        :param code:  (required)
        :type code: str
        :param display_name:  The name of the Fund.
        :type display_name: str
        :param description:  A description for the Fund.
        :type description: str
        :param dealing_filters:  The set of filters used to decide which JE lines are included in the dealing. (required)
        :type dealing_filters: list[lusid.ComponentFilter]
        :param pnl_filters:  The set of filters used to decide which JE lines are included in the PnL. (required)
        :type pnl_filters: list[lusid.ComponentFilter]
        :param back_out_filters:  The set of filters used to decide which JE lines are included in the back outs. (required)
        :type back_out_filters: list[lusid.ComponentFilter]
        :param properties:  A set of properties for the Fund Configuration.
        :type properties: dict[str, lusid.ModelProperty]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._code = None
        self._display_name = None
        self._description = None
        self._dealing_filters = None
        self._pnl_filters = None
        self._back_out_filters = None
        self._properties = None
        self.discriminator = None

        self.code = code
        self.display_name = display_name
        self.description = description
        self.dealing_filters = dealing_filters
        self.pnl_filters = pnl_filters
        self.back_out_filters = back_out_filters
        self.properties = properties

    @property
    def code(self):
        """Gets the code of this FundConfigurationRequest.  # noqa: E501


        :return: The code of this FundConfigurationRequest.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this FundConfigurationRequest.


        :param code: The code of this FundConfigurationRequest.  # noqa: E501
        :type code: str
        """
        if self.local_vars_configuration.client_side_validation and code is None:  # noqa: E501
            raise ValueError("Invalid value for `code`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                code is not None and len(code) > 64):
            raise ValueError("Invalid value for `code`, length must be less than or equal to `64`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                code is not None and len(code) < 1):
            raise ValueError("Invalid value for `code`, length must be greater than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                code is not None and not re.search(r'^[a-zA-Z0-9\-_]+$', code)):  # noqa: E501
            raise ValueError(r"Invalid value for `code`, must be a follow pattern or equal to `/^[a-zA-Z0-9\-_]+$/`")  # noqa: E501

        self._code = code

    @property
    def display_name(self):
        """Gets the display_name of this FundConfigurationRequest.  # noqa: E501

        The name of the Fund.  # noqa: E501

        :return: The display_name of this FundConfigurationRequest.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this FundConfigurationRequest.

        The name of the Fund.  # noqa: E501

        :param display_name: The display_name of this FundConfigurationRequest.  # noqa: E501
        :type display_name: str
        """
        if (self.local_vars_configuration.client_side_validation and
                display_name is not None and len(display_name) > 256):
            raise ValueError("Invalid value for `display_name`, length must be less than or equal to `256`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                display_name is not None and len(display_name) < 1):
            raise ValueError("Invalid value for `display_name`, length must be greater than or equal to `1`")  # noqa: E501

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this FundConfigurationRequest.  # noqa: E501

        A description for the Fund.  # noqa: E501

        :return: The description of this FundConfigurationRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this FundConfigurationRequest.

        A description for the Fund.  # noqa: E501

        :param description: The description of this FundConfigurationRequest.  # noqa: E501
        :type description: str
        """
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) > 1024):
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1024`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) < 0):
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `0`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and not re.search(r'^[\s\S]*$', description)):  # noqa: E501
            raise ValueError(r"Invalid value for `description`, must be a follow pattern or equal to `/^[\s\S]*$/`")  # noqa: E501

        self._description = description

    @property
    def dealing_filters(self):
        """Gets the dealing_filters of this FundConfigurationRequest.  # noqa: E501

        The set of filters used to decide which JE lines are included in the dealing.  # noqa: E501

        :return: The dealing_filters of this FundConfigurationRequest.  # noqa: E501
        :rtype: list[lusid.ComponentFilter]
        """
        return self._dealing_filters

    @dealing_filters.setter
    def dealing_filters(self, dealing_filters):
        """Sets the dealing_filters of this FundConfigurationRequest.

        The set of filters used to decide which JE lines are included in the dealing.  # noqa: E501

        :param dealing_filters: The dealing_filters of this FundConfigurationRequest.  # noqa: E501
        :type dealing_filters: list[lusid.ComponentFilter]
        """
        if self.local_vars_configuration.client_side_validation and dealing_filters is None:  # noqa: E501
            raise ValueError("Invalid value for `dealing_filters`, must not be `None`")  # noqa: E501

        self._dealing_filters = dealing_filters

    @property
    def pnl_filters(self):
        """Gets the pnl_filters of this FundConfigurationRequest.  # noqa: E501

        The set of filters used to decide which JE lines are included in the PnL.  # noqa: E501

        :return: The pnl_filters of this FundConfigurationRequest.  # noqa: E501
        :rtype: list[lusid.ComponentFilter]
        """
        return self._pnl_filters

    @pnl_filters.setter
    def pnl_filters(self, pnl_filters):
        """Sets the pnl_filters of this FundConfigurationRequest.

        The set of filters used to decide which JE lines are included in the PnL.  # noqa: E501

        :param pnl_filters: The pnl_filters of this FundConfigurationRequest.  # noqa: E501
        :type pnl_filters: list[lusid.ComponentFilter]
        """
        if self.local_vars_configuration.client_side_validation and pnl_filters is None:  # noqa: E501
            raise ValueError("Invalid value for `pnl_filters`, must not be `None`")  # noqa: E501

        self._pnl_filters = pnl_filters

    @property
    def back_out_filters(self):
        """Gets the back_out_filters of this FundConfigurationRequest.  # noqa: E501

        The set of filters used to decide which JE lines are included in the back outs.  # noqa: E501

        :return: The back_out_filters of this FundConfigurationRequest.  # noqa: E501
        :rtype: list[lusid.ComponentFilter]
        """
        return self._back_out_filters

    @back_out_filters.setter
    def back_out_filters(self, back_out_filters):
        """Sets the back_out_filters of this FundConfigurationRequest.

        The set of filters used to decide which JE lines are included in the back outs.  # noqa: E501

        :param back_out_filters: The back_out_filters of this FundConfigurationRequest.  # noqa: E501
        :type back_out_filters: list[lusid.ComponentFilter]
        """
        if self.local_vars_configuration.client_side_validation and back_out_filters is None:  # noqa: E501
            raise ValueError("Invalid value for `back_out_filters`, must not be `None`")  # noqa: E501

        self._back_out_filters = back_out_filters

    @property
    def properties(self):
        """Gets the properties of this FundConfigurationRequest.  # noqa: E501

        A set of properties for the Fund Configuration.  # noqa: E501

        :return: The properties of this FundConfigurationRequest.  # noqa: E501
        :rtype: dict[str, lusid.ModelProperty]
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this FundConfigurationRequest.

        A set of properties for the Fund Configuration.  # noqa: E501

        :param properties: The properties of this FundConfigurationRequest.  # noqa: E501
        :type properties: dict[str, lusid.ModelProperty]
        """

        self._properties = properties

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FundConfigurationRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FundConfigurationRequest):
            return True

        return self.to_dict() != other.to_dict()
