# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.237
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class HoldingContributor(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'transaction': 'Transaction',
        'holding_id': 'int'
    }

    attribute_map = {
        'transaction': 'transaction',
        'holding_id': 'holdingId'
    }

    required_map = {
        'transaction': 'required',
        'holding_id': 'optional'
    }

    def __init__(self, transaction=None, holding_id=None, local_vars_configuration=None):  # noqa: E501
        """HoldingContributor - a model defined in OpenAPI"
        
        :param transaction:  (required)
        :type transaction: lusid.Transaction
        :param holding_id:  The unique holding identifier
        :type holding_id: int

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._transaction = None
        self._holding_id = None
        self.discriminator = None

        self.transaction = transaction
        self.holding_id = holding_id

    @property
    def transaction(self):
        """Gets the transaction of this HoldingContributor.  # noqa: E501


        :return: The transaction of this HoldingContributor.  # noqa: E501
        :rtype: lusid.Transaction
        """
        return self._transaction

    @transaction.setter
    def transaction(self, transaction):
        """Sets the transaction of this HoldingContributor.


        :param transaction: The transaction of this HoldingContributor.  # noqa: E501
        :type transaction: lusid.Transaction
        """
        if self.local_vars_configuration.client_side_validation and transaction is None:  # noqa: E501
            raise ValueError("Invalid value for `transaction`, must not be `None`")  # noqa: E501

        self._transaction = transaction

    @property
    def holding_id(self):
        """Gets the holding_id of this HoldingContributor.  # noqa: E501

        The unique holding identifier  # noqa: E501

        :return: The holding_id of this HoldingContributor.  # noqa: E501
        :rtype: int
        """
        return self._holding_id

    @holding_id.setter
    def holding_id(self, holding_id):
        """Sets the holding_id of this HoldingContributor.

        The unique holding identifier  # noqa: E501

        :param holding_id: The holding_id of this HoldingContributor.  # noqa: E501
        :type holding_id: int
        """

        self._holding_id = holding_id

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HoldingContributor):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, HoldingContributor):
            return True

        return self.to_dict() != other.to_dict()
