# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.237
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class ShareClassPnlBreakdown(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'apportioned_non_class_specific_pnl': 'dict(str, ShareClassAmount)',
        'class_pnl': 'dict(str, ShareClassAmount)',
        'total_pnl': 'dict(str, ShareClassAmount)'
    }

    attribute_map = {
        'apportioned_non_class_specific_pnl': 'apportionedNonClassSpecificPnl',
        'class_pnl': 'classPnl',
        'total_pnl': 'totalPnl'
    }

    required_map = {
        'apportioned_non_class_specific_pnl': 'required',
        'class_pnl': 'required',
        'total_pnl': 'required'
    }

    def __init__(self, apportioned_non_class_specific_pnl=None, class_pnl=None, total_pnl=None, local_vars_configuration=None):  # noqa: E501
        """ShareClassPnlBreakdown - a model defined in OpenAPI"
        
        :param apportioned_non_class_specific_pnl:  Bucket of detail for PnL within the queried period not explicitly allocated to any share class but has been apportioned to the share class. (required)
        :type apportioned_non_class_specific_pnl: dict[str, lusid.ShareClassAmount]
        :param class_pnl:  Bucket of detail for PnL specific to the share class within the queried period. (required)
        :type class_pnl: dict[str, lusid.ShareClassAmount]
        :param total_pnl:  Bucket of detail for the sum of class PnL and PnL not specific to a class within the queried period. (required)
        :type total_pnl: dict[str, lusid.ShareClassAmount]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._apportioned_non_class_specific_pnl = None
        self._class_pnl = None
        self._total_pnl = None
        self.discriminator = None

        self.apportioned_non_class_specific_pnl = apportioned_non_class_specific_pnl
        self.class_pnl = class_pnl
        self.total_pnl = total_pnl

    @property
    def apportioned_non_class_specific_pnl(self):
        """Gets the apportioned_non_class_specific_pnl of this ShareClassPnlBreakdown.  # noqa: E501

        Bucket of detail for PnL within the queried period not explicitly allocated to any share class but has been apportioned to the share class.  # noqa: E501

        :return: The apportioned_non_class_specific_pnl of this ShareClassPnlBreakdown.  # noqa: E501
        :rtype: dict[str, lusid.ShareClassAmount]
        """
        return self._apportioned_non_class_specific_pnl

    @apportioned_non_class_specific_pnl.setter
    def apportioned_non_class_specific_pnl(self, apportioned_non_class_specific_pnl):
        """Sets the apportioned_non_class_specific_pnl of this ShareClassPnlBreakdown.

        Bucket of detail for PnL within the queried period not explicitly allocated to any share class but has been apportioned to the share class.  # noqa: E501

        :param apportioned_non_class_specific_pnl: The apportioned_non_class_specific_pnl of this ShareClassPnlBreakdown.  # noqa: E501
        :type apportioned_non_class_specific_pnl: dict[str, lusid.ShareClassAmount]
        """
        if self.local_vars_configuration.client_side_validation and apportioned_non_class_specific_pnl is None:  # noqa: E501
            raise ValueError("Invalid value for `apportioned_non_class_specific_pnl`, must not be `None`")  # noqa: E501

        self._apportioned_non_class_specific_pnl = apportioned_non_class_specific_pnl

    @property
    def class_pnl(self):
        """Gets the class_pnl of this ShareClassPnlBreakdown.  # noqa: E501

        Bucket of detail for PnL specific to the share class within the queried period.  # noqa: E501

        :return: The class_pnl of this ShareClassPnlBreakdown.  # noqa: E501
        :rtype: dict[str, lusid.ShareClassAmount]
        """
        return self._class_pnl

    @class_pnl.setter
    def class_pnl(self, class_pnl):
        """Sets the class_pnl of this ShareClassPnlBreakdown.

        Bucket of detail for PnL specific to the share class within the queried period.  # noqa: E501

        :param class_pnl: The class_pnl of this ShareClassPnlBreakdown.  # noqa: E501
        :type class_pnl: dict[str, lusid.ShareClassAmount]
        """
        if self.local_vars_configuration.client_side_validation and class_pnl is None:  # noqa: E501
            raise ValueError("Invalid value for `class_pnl`, must not be `None`")  # noqa: E501

        self._class_pnl = class_pnl

    @property
    def total_pnl(self):
        """Gets the total_pnl of this ShareClassPnlBreakdown.  # noqa: E501

        Bucket of detail for the sum of class PnL and PnL not specific to a class within the queried period.  # noqa: E501

        :return: The total_pnl of this ShareClassPnlBreakdown.  # noqa: E501
        :rtype: dict[str, lusid.ShareClassAmount]
        """
        return self._total_pnl

    @total_pnl.setter
    def total_pnl(self, total_pnl):
        """Sets the total_pnl of this ShareClassPnlBreakdown.

        Bucket of detail for the sum of class PnL and PnL not specific to a class within the queried period.  # noqa: E501

        :param total_pnl: The total_pnl of this ShareClassPnlBreakdown.  # noqa: E501
        :type total_pnl: dict[str, lusid.ShareClassAmount]
        """
        if self.local_vars_configuration.client_side_validation and total_pnl is None:  # noqa: E501
            raise ValueError("Invalid value for `total_pnl`, must not be `None`")  # noqa: E501

        self._total_pnl = total_pnl

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ShareClassPnlBreakdown):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ShareClassPnlBreakdown):
            return True

        return self.to_dict() != other.to_dict()
