# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.237
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class SimpleRoundingConvention(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'precision': 'int',
        'rounding_type': 'str'
    }

    attribute_map = {
        'precision': 'precision',
        'rounding_type': 'roundingType'
    }

    required_map = {
        'precision': 'optional',
        'rounding_type': 'optional'
    }

    def __init__(self, precision=None, rounding_type=None, local_vars_configuration=None):  # noqa: E501
        """SimpleRoundingConvention - a model defined in OpenAPI"
        
        :param precision:  The precision of the rounding. The decimal places or significant figures to which the rounding takes place.
        :type precision: int
        :param rounding_type:  The type of rounding.  e.g. Round Up, Round Down    Supported string (enumeration) values are: [Down, Up, Nearest].
        :type rounding_type: str

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._precision = None
        self._rounding_type = None
        self.discriminator = None

        if precision is not None:
            self.precision = precision
        self.rounding_type = rounding_type

    @property
    def precision(self):
        """Gets the precision of this SimpleRoundingConvention.  # noqa: E501

        The precision of the rounding. The decimal places or significant figures to which the rounding takes place.  # noqa: E501

        :return: The precision of this SimpleRoundingConvention.  # noqa: E501
        :rtype: int
        """
        return self._precision

    @precision.setter
    def precision(self, precision):
        """Sets the precision of this SimpleRoundingConvention.

        The precision of the rounding. The decimal places or significant figures to which the rounding takes place.  # noqa: E501

        :param precision: The precision of this SimpleRoundingConvention.  # noqa: E501
        :type precision: int
        """

        self._precision = precision

    @property
    def rounding_type(self):
        """Gets the rounding_type of this SimpleRoundingConvention.  # noqa: E501

        The type of rounding.  e.g. Round Up, Round Down    Supported string (enumeration) values are: [Down, Up, Nearest].  # noqa: E501

        :return: The rounding_type of this SimpleRoundingConvention.  # noqa: E501
        :rtype: str
        """
        return self._rounding_type

    @rounding_type.setter
    def rounding_type(self, rounding_type):
        """Sets the rounding_type of this SimpleRoundingConvention.

        The type of rounding.  e.g. Round Up, Round Down    Supported string (enumeration) values are: [Down, Up, Nearest].  # noqa: E501

        :param rounding_type: The rounding_type of this SimpleRoundingConvention.  # noqa: E501
        :type rounding_type: str
        """

        self._rounding_type = rounding_type

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SimpleRoundingConvention):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SimpleRoundingConvention):
            return True

        return self.to_dict() != other.to_dict()
