# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.237
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class SpecificHoldingPricingInfo(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'dependency_source_filter': 'DependencySourceFilter',
        'field': 'str'
    }

    attribute_map = {
        'dependency_source_filter': 'dependencySourceFilter',
        'field': 'field'
    }

    required_map = {
        'dependency_source_filter': 'required',
        'field': 'required'
    }

    def __init__(self, dependency_source_filter=None, field=None, local_vars_configuration=None):  # noqa: E501
        """SpecificHoldingPricingInfo - a model defined in OpenAPI"
        
        :param dependency_source_filter:  (required)
        :type dependency_source_filter: lusid.DependencySourceFilter
        :param field:  The Holding field which the fallback/override should use to create a price quote. (required)
        :type field: str

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._dependency_source_filter = None
        self._field = None
        self.discriminator = None

        self.dependency_source_filter = dependency_source_filter
        self.field = field

    @property
    def dependency_source_filter(self):
        """Gets the dependency_source_filter of this SpecificHoldingPricingInfo.  # noqa: E501


        :return: The dependency_source_filter of this SpecificHoldingPricingInfo.  # noqa: E501
        :rtype: lusid.DependencySourceFilter
        """
        return self._dependency_source_filter

    @dependency_source_filter.setter
    def dependency_source_filter(self, dependency_source_filter):
        """Sets the dependency_source_filter of this SpecificHoldingPricingInfo.


        :param dependency_source_filter: The dependency_source_filter of this SpecificHoldingPricingInfo.  # noqa: E501
        :type dependency_source_filter: lusid.DependencySourceFilter
        """
        if self.local_vars_configuration.client_side_validation and dependency_source_filter is None:  # noqa: E501
            raise ValueError("Invalid value for `dependency_source_filter`, must not be `None`")  # noqa: E501

        self._dependency_source_filter = dependency_source_filter

    @property
    def field(self):
        """Gets the field of this SpecificHoldingPricingInfo.  # noqa: E501

        The Holding field which the fallback/override should use to create a price quote.  # noqa: E501

        :return: The field of this SpecificHoldingPricingInfo.  # noqa: E501
        :rtype: str
        """
        return self._field

    @field.setter
    def field(self, field):
        """Sets the field of this SpecificHoldingPricingInfo.

        The Holding field which the fallback/override should use to create a price quote.  # noqa: E501

        :param field: The field of this SpecificHoldingPricingInfo.  # noqa: E501
        :type field: str
        """
        if self.local_vars_configuration.client_side_validation and field is None:  # noqa: E501
            raise ValueError("Invalid value for `field`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                field is not None and len(field) < 1):
            raise ValueError("Invalid value for `field`, length must be greater than or equal to `1`")  # noqa: E501

        self._field = field

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SpecificHoldingPricingInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SpecificHoldingPricingInfo):
            return True

        return self.to_dict() != other.to_dict()
