# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.237
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class TransactionDiagnostics(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'transaction_display_name': 'str',
        'error_details': 'list[str]'
    }

    attribute_map = {
        'transaction_display_name': 'transactionDisplayName',
        'error_details': 'errorDetails'
    }

    required_map = {
        'transaction_display_name': 'required',
        'error_details': 'required'
    }

    def __init__(self, transaction_display_name=None, error_details=None, local_vars_configuration=None):  # noqa: E501
        """TransactionDiagnostics - a model defined in OpenAPI"
        
        :param transaction_display_name:  (required)
        :type transaction_display_name: str
        :param error_details:  (required)
        :type error_details: list[str]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._transaction_display_name = None
        self._error_details = None
        self.discriminator = None

        self.transaction_display_name = transaction_display_name
        self.error_details = error_details

    @property
    def transaction_display_name(self):
        """Gets the transaction_display_name of this TransactionDiagnostics.  # noqa: E501


        :return: The transaction_display_name of this TransactionDiagnostics.  # noqa: E501
        :rtype: str
        """
        return self._transaction_display_name

    @transaction_display_name.setter
    def transaction_display_name(self, transaction_display_name):
        """Sets the transaction_display_name of this TransactionDiagnostics.


        :param transaction_display_name: The transaction_display_name of this TransactionDiagnostics.  # noqa: E501
        :type transaction_display_name: str
        """
        if self.local_vars_configuration.client_side_validation and transaction_display_name is None:  # noqa: E501
            raise ValueError("Invalid value for `transaction_display_name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                transaction_display_name is not None and len(transaction_display_name) < 1):
            raise ValueError("Invalid value for `transaction_display_name`, length must be greater than or equal to `1`")  # noqa: E501

        self._transaction_display_name = transaction_display_name

    @property
    def error_details(self):
        """Gets the error_details of this TransactionDiagnostics.  # noqa: E501


        :return: The error_details of this TransactionDiagnostics.  # noqa: E501
        :rtype: list[str]
        """
        return self._error_details

    @error_details.setter
    def error_details(self, error_details):
        """Sets the error_details of this TransactionDiagnostics.


        :param error_details: The error_details of this TransactionDiagnostics.  # noqa: E501
        :type error_details: list[str]
        """
        if self.local_vars_configuration.client_side_validation and error_details is None:  # noqa: E501
            raise ValueError("Invalid value for `error_details`, must not be `None`")  # noqa: E501

        self._error_details = error_details

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TransactionDiagnostics):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TransactionDiagnostics):
            return True

        return self.to_dict() != other.to_dict()
