# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.237
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class UpdateGroupReconciliationDefinitionRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'display_name': 'str',
        'description': 'str',
        'portfolio_entity_ids': 'GroupReconciliationDefinitionPortfolioEntityIds',
        'recipe_ids': 'GroupReconciliationDefinitionRecipeIds',
        'currencies': 'GroupReconciliationDefinitionCurrencies',
        'transaction_date_windows': 'TransactionDateWindows',
        'comparison_ruleset_ids': 'GroupReconciliationDefinitionComparisonRulesetIds',
        'break_code_source': 'BreakCodeSource'
    }

    attribute_map = {
        'display_name': 'displayName',
        'description': 'description',
        'portfolio_entity_ids': 'portfolioEntityIds',
        'recipe_ids': 'recipeIds',
        'currencies': 'currencies',
        'transaction_date_windows': 'transactionDateWindows',
        'comparison_ruleset_ids': 'comparisonRulesetIds',
        'break_code_source': 'breakCodeSource'
    }

    required_map = {
        'display_name': 'required',
        'description': 'required',
        'portfolio_entity_ids': 'required',
        'recipe_ids': 'optional',
        'currencies': 'optional',
        'transaction_date_windows': 'optional',
        'comparison_ruleset_ids': 'optional',
        'break_code_source': 'required'
    }

    def __init__(self, display_name=None, description=None, portfolio_entity_ids=None, recipe_ids=None, currencies=None, transaction_date_windows=None, comparison_ruleset_ids=None, break_code_source=None, local_vars_configuration=None):  # noqa: E501
        """UpdateGroupReconciliationDefinitionRequest - a model defined in OpenAPI"
        
        :param display_name:  The name of the Group Reconciliation Definition (required)
        :type display_name: str
        :param description:  The description of the Group Reconciliation Definition (required)
        :type description: str
        :param portfolio_entity_ids:  (required)
        :type portfolio_entity_ids: lusid.GroupReconciliationDefinitionPortfolioEntityIds
        :param recipe_ids: 
        :type recipe_ids: lusid.GroupReconciliationDefinitionRecipeIds
        :param currencies: 
        :type currencies: lusid.GroupReconciliationDefinitionCurrencies
        :param transaction_date_windows: 
        :type transaction_date_windows: lusid.TransactionDateWindows
        :param comparison_ruleset_ids: 
        :type comparison_ruleset_ids: lusid.GroupReconciliationDefinitionComparisonRulesetIds
        :param break_code_source:  (required)
        :type break_code_source: lusid.BreakCodeSource

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._display_name = None
        self._description = None
        self._portfolio_entity_ids = None
        self._recipe_ids = None
        self._currencies = None
        self._transaction_date_windows = None
        self._comparison_ruleset_ids = None
        self._break_code_source = None
        self.discriminator = None

        self.display_name = display_name
        self.description = description
        self.portfolio_entity_ids = portfolio_entity_ids
        if recipe_ids is not None:
            self.recipe_ids = recipe_ids
        if currencies is not None:
            self.currencies = currencies
        if transaction_date_windows is not None:
            self.transaction_date_windows = transaction_date_windows
        if comparison_ruleset_ids is not None:
            self.comparison_ruleset_ids = comparison_ruleset_ids
        self.break_code_source = break_code_source

    @property
    def display_name(self):
        """Gets the display_name of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501

        The name of the Group Reconciliation Definition  # noqa: E501

        :return: The display_name of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this UpdateGroupReconciliationDefinitionRequest.

        The name of the Group Reconciliation Definition  # noqa: E501

        :param display_name: The display_name of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :type display_name: str
        """
        if self.local_vars_configuration.client_side_validation and display_name is None:  # noqa: E501
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                display_name is not None and len(display_name) < 1):
            raise ValueError("Invalid value for `display_name`, length must be greater than or equal to `1`")  # noqa: E501

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501

        The description of the Group Reconciliation Definition  # noqa: E501

        :return: The description of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UpdateGroupReconciliationDefinitionRequest.

        The description of the Group Reconciliation Definition  # noqa: E501

        :param description: The description of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :type description: str
        """
        if self.local_vars_configuration.client_side_validation and description is None:  # noqa: E501
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) < 1):
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `1`")  # noqa: E501

        self._description = description

    @property
    def portfolio_entity_ids(self):
        """Gets the portfolio_entity_ids of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501


        :return: The portfolio_entity_ids of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :rtype: lusid.GroupReconciliationDefinitionPortfolioEntityIds
        """
        return self._portfolio_entity_ids

    @portfolio_entity_ids.setter
    def portfolio_entity_ids(self, portfolio_entity_ids):
        """Sets the portfolio_entity_ids of this UpdateGroupReconciliationDefinitionRequest.


        :param portfolio_entity_ids: The portfolio_entity_ids of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :type portfolio_entity_ids: lusid.GroupReconciliationDefinitionPortfolioEntityIds
        """
        if self.local_vars_configuration.client_side_validation and portfolio_entity_ids is None:  # noqa: E501
            raise ValueError("Invalid value for `portfolio_entity_ids`, must not be `None`")  # noqa: E501

        self._portfolio_entity_ids = portfolio_entity_ids

    @property
    def recipe_ids(self):
        """Gets the recipe_ids of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501


        :return: The recipe_ids of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :rtype: lusid.GroupReconciliationDefinitionRecipeIds
        """
        return self._recipe_ids

    @recipe_ids.setter
    def recipe_ids(self, recipe_ids):
        """Sets the recipe_ids of this UpdateGroupReconciliationDefinitionRequest.


        :param recipe_ids: The recipe_ids of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :type recipe_ids: lusid.GroupReconciliationDefinitionRecipeIds
        """

        self._recipe_ids = recipe_ids

    @property
    def currencies(self):
        """Gets the currencies of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501


        :return: The currencies of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :rtype: lusid.GroupReconciliationDefinitionCurrencies
        """
        return self._currencies

    @currencies.setter
    def currencies(self, currencies):
        """Sets the currencies of this UpdateGroupReconciliationDefinitionRequest.


        :param currencies: The currencies of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :type currencies: lusid.GroupReconciliationDefinitionCurrencies
        """

        self._currencies = currencies

    @property
    def transaction_date_windows(self):
        """Gets the transaction_date_windows of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501


        :return: The transaction_date_windows of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :rtype: lusid.TransactionDateWindows
        """
        return self._transaction_date_windows

    @transaction_date_windows.setter
    def transaction_date_windows(self, transaction_date_windows):
        """Sets the transaction_date_windows of this UpdateGroupReconciliationDefinitionRequest.


        :param transaction_date_windows: The transaction_date_windows of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :type transaction_date_windows: lusid.TransactionDateWindows
        """

        self._transaction_date_windows = transaction_date_windows

    @property
    def comparison_ruleset_ids(self):
        """Gets the comparison_ruleset_ids of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501


        :return: The comparison_ruleset_ids of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :rtype: lusid.GroupReconciliationDefinitionComparisonRulesetIds
        """
        return self._comparison_ruleset_ids

    @comparison_ruleset_ids.setter
    def comparison_ruleset_ids(self, comparison_ruleset_ids):
        """Sets the comparison_ruleset_ids of this UpdateGroupReconciliationDefinitionRequest.


        :param comparison_ruleset_ids: The comparison_ruleset_ids of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :type comparison_ruleset_ids: lusid.GroupReconciliationDefinitionComparisonRulesetIds
        """

        self._comparison_ruleset_ids = comparison_ruleset_ids

    @property
    def break_code_source(self):
        """Gets the break_code_source of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501


        :return: The break_code_source of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :rtype: lusid.BreakCodeSource
        """
        return self._break_code_source

    @break_code_source.setter
    def break_code_source(self, break_code_source):
        """Sets the break_code_source of this UpdateGroupReconciliationDefinitionRequest.


        :param break_code_source: The break_code_source of this UpdateGroupReconciliationDefinitionRequest.  # noqa: E501
        :type break_code_source: lusid.BreakCodeSource
        """
        if self.local_vars_configuration.client_side_validation and break_code_source is None:  # noqa: E501
            raise ValueError("Invalid value for `break_code_source`, must not be `None`")  # noqa: E501

        self._break_code_source = break_code_source

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateGroupReconciliationDefinitionRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpdateGroupReconciliationDefinitionRequest):
            return True

        return self.to_dict() != other.to_dict()
