# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.237
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class UpsertReferencePortfolioConstituentPropertiesRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'identifiers': 'dict(str, str)',
        'properties': 'dict(str, PerpetualProperty)'
    }

    attribute_map = {
        'identifiers': 'identifiers',
        'properties': 'properties'
    }

    required_map = {
        'identifiers': 'required',
        'properties': 'required'
    }

    def __init__(self, identifiers=None, properties=None, local_vars_configuration=None):  # noqa: E501
        """UpsertReferencePortfolioConstituentPropertiesRequest - a model defined in OpenAPI"
        
        :param identifiers:  A set of instrument identifiers that can resolve the constituent to a unique instrument. (required)
        :type identifiers: dict(str, str)
        :param properties:  The updated collection of properties of the constituent. (required)
        :type properties: dict[str, lusid.PerpetualProperty]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._identifiers = None
        self._properties = None
        self.discriminator = None

        self.identifiers = identifiers
        self.properties = properties

    @property
    def identifiers(self):
        """Gets the identifiers of this UpsertReferencePortfolioConstituentPropertiesRequest.  # noqa: E501

        A set of instrument identifiers that can resolve the constituent to a unique instrument.  # noqa: E501

        :return: The identifiers of this UpsertReferencePortfolioConstituentPropertiesRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._identifiers

    @identifiers.setter
    def identifiers(self, identifiers):
        """Sets the identifiers of this UpsertReferencePortfolioConstituentPropertiesRequest.

        A set of instrument identifiers that can resolve the constituent to a unique instrument.  # noqa: E501

        :param identifiers: The identifiers of this UpsertReferencePortfolioConstituentPropertiesRequest.  # noqa: E501
        :type identifiers: dict(str, str)
        """
        if self.local_vars_configuration.client_side_validation and identifiers is None:  # noqa: E501
            raise ValueError("Invalid value for `identifiers`, must not be `None`")  # noqa: E501

        self._identifiers = identifiers

    @property
    def properties(self):
        """Gets the properties of this UpsertReferencePortfolioConstituentPropertiesRequest.  # noqa: E501

        The updated collection of properties of the constituent.  # noqa: E501

        :return: The properties of this UpsertReferencePortfolioConstituentPropertiesRequest.  # noqa: E501
        :rtype: dict[str, lusid.PerpetualProperty]
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this UpsertReferencePortfolioConstituentPropertiesRequest.

        The updated collection of properties of the constituent.  # noqa: E501

        :param properties: The properties of this UpsertReferencePortfolioConstituentPropertiesRequest.  # noqa: E501
        :type properties: dict[str, lusid.PerpetualProperty]
        """
        if self.local_vars_configuration.client_side_validation and properties is None:  # noqa: E501
            raise ValueError("Invalid value for `properties`, must not be `None`")  # noqa: E501

        self._properties = properties

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpsertReferencePortfolioConstituentPropertiesRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpsertReferencePortfolioConstituentPropertiesRequest):
            return True

        return self.to_dict() != other.to_dict()
