# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.237
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class ValuationPointDataRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'diary_entry_code': 'str'
    }

    attribute_map = {
        'diary_entry_code': 'diaryEntryCode'
    }

    required_map = {
        'diary_entry_code': 'required'
    }

    def __init__(self, diary_entry_code=None, local_vars_configuration=None):  # noqa: E501
        """ValuationPointDataRequest - a model defined in OpenAPI"
        
        :param diary_entry_code:  Unique code for the Valuation Point. (required)
        :type diary_entry_code: str

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._diary_entry_code = None
        self.discriminator = None

        self.diary_entry_code = diary_entry_code

    @property
    def diary_entry_code(self):
        """Gets the diary_entry_code of this ValuationPointDataRequest.  # noqa: E501

        Unique code for the Valuation Point.  # noqa: E501

        :return: The diary_entry_code of this ValuationPointDataRequest.  # noqa: E501
        :rtype: str
        """
        return self._diary_entry_code

    @diary_entry_code.setter
    def diary_entry_code(self, diary_entry_code):
        """Sets the diary_entry_code of this ValuationPointDataRequest.

        Unique code for the Valuation Point.  # noqa: E501

        :param diary_entry_code: The diary_entry_code of this ValuationPointDataRequest.  # noqa: E501
        :type diary_entry_code: str
        """
        if self.local_vars_configuration.client_side_validation and diary_entry_code is None:  # noqa: E501
            raise ValueError("Invalid value for `diary_entry_code`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                diary_entry_code is not None and len(diary_entry_code) > 64):
            raise ValueError("Invalid value for `diary_entry_code`, length must be less than or equal to `64`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                diary_entry_code is not None and len(diary_entry_code) < 1):
            raise ValueError("Invalid value for `diary_entry_code`, length must be greater than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                diary_entry_code is not None and not re.search(r'^[a-zA-Z0-9\-_]+$', diary_entry_code)):  # noqa: E501
            raise ValueError(r"Invalid value for `diary_entry_code`, must be a follow pattern or equal to `/^[a-zA-Z0-9\-_]+$/`")  # noqa: E501

        self._diary_entry_code = diary_entry_code

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ValuationPointDataRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ValuationPointDataRequest):
            return True

        return self.to_dict() != other.to_dict()
